-- get the addon namespace
local addon, ns = ...

-- get the config values
local cfg = ns.cfg

local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

lib.classes = {}
lib.classpreload = {}
lib.classpostload = {}


function lib.defaults()
	cfg.gcd=1
	--cfg.xRes, cfg.yRes = string.match(({GetScreenResolutions()})[GetCurrentResolution()], "(%d+)x(%d+)")
	cfg.uiscale = UIParent:GetScale()
	cfg.aspectratio=GetMonitorAspectRatio()

	cfg.FindPriority=nil
	cfg.Update=nil

	cfg.target='normal'
	cfg.class = select(2,UnitClass("player"))
	cfg.npc={}

	cfg.Power={}
	cfg.Power.now=UnitPower("player")
	cfg.Power.type_num,cfg.Power.type=UnitPowerType("player")
	cfg.Power.max=UnitPowerMax("player")
	cfg.Power.regen = (select(2,GetPowerRegen()))
	cfg.Power.real=cfg.Power.now
	cfg.Power.local_type=_G[cfg.Power.type]
	cfg.Power.onpower=nil
	cfg.Power.Power=true

	cfg.AltPower={}
	cfg.AltPower.now=0
	cfg.AltPower.max=0
	-- cfg.AltPower.type_num=cfg.Power.type_num
	cfg.AltPower.func=nil
	cfg.AltPower.local_type=nil
	cfg.AltPower.Power=false

	--cfg.local_casttime=hedlib.BlizzPattern(_G["SPELL_CAST_TIME_SEC"])
	--[[cfg.local_cd={}
	table.insert(cfg.local_cd,hedlib.BlizzPattern(_G["SPELL_RECAST_TIME_SEC"]))
	table.insert(cfg.local_cd,hedlib.BlizzPattern(_G["SPELL_RECAST_TIME_CHARGES_SEC"]))]]
	--cfg.local_cd=hedlib.BlizzPattern2({SPELL_RECAST_TIME_SEC,SPELL_RECAST_TIME_CHARGES_SEC})
	cfg.local_cd=hedlib.BlizzPattern(SPELL_RECAST_TIME_SEC)
	cfg.lastUpdate=0
	cfg.lastUpdateBar=0
	cfg.nextUpdate=0

	cfg.GUID={}
	cfg.GUID["player"] = UnitGUID("player") or 0
	cfg.GUID["pet"] = UnitGUID("pet") or 0
	cfg.GUID["target"] = UnitGUID("target") or 0

	cfg.mounted=IsMounted()

	cfg.gcd_spell=nil
	cfg.classfound=nil
	--cfg.now=GetTime()
	cfg.timeleft=0
	cfg.maxmintime = 21
	cfg.ctimeleft = cfg.maxmintime

	cfg.health={}
	cfg.health["target"]={}
	-- cfg.health["target"].max=UnitHealthMax("target") or 0
	-- cfg.health["target"].now=UnitHealth("target") or 0
	-- cfg.health["target"].percent=(cfg.health["target"].max==0) and 100 or hedlib.round(cfg.health["target"].now*100/cfg.health["target"].max,0)

	cfg.health["player"]={}
	-- cfg.health["player"].max=UnitHealthMax("target") or 0
	-- cfg.health["player"].now=UnitHealth("target") or 0
	-- cfg.health["player"].percent=(cfg.health["player"].max==0) and 100 or hedlib.round(cfg.health["player"].now*100/cfg.health["player"].max,0)

	cfg.nousecheck=false

	cfg.onupdate=nil
	cfg.onpower=nil
	cfg.onhealth=nil

	cfg.case = {}
	cfg.items = {}
	cfg.spell_cd=0
	cfg.spell_wait=0
	cfg.spells = {}
	cfg.spell_alias = {}
	cfg.spells_updating = {}
	cfg.sspell = {}
	cfg.spell_tt=_G["Hedd_Tooltip_test"] or CreateFrame('GameTooltip', "Hedd_Tooltip_test", nil, 'GameTooltipTemplate')
	cfg.spell_tt:SetOwner(UIParent, 'ANCHOR_NONE')

	cfg.sp_conv={}
	cfg.id2aura={}
	cfg.id2spell={}
	cfg.aura = {}
	cfg.aura_seen={}

	cfg.aura_unit_id = {}
	cfg.aura_found={}
	cfg.auras ={}
	cfg.saura ={}
	cfg.plist = {}
	cfg.spellcast = {}
	cfg.lastspell_time=nil
	cfg.watchunits={}
	Heddevents = {}
	Heddclassevents = {}
	--cfg.combo = GetComboPoints('player', 'target')
	--cfg.holy = UnitPower("player" , SPELL_POWER_HOLY_POWER)
	cfg.tier={}
	cfg.tieritems={}
	cfg.equip={}
	cfg.equipment={}
	cfg.equipslot={}
	cfg.SLLegendary={}
	cfg.SLLegendary.BonusID={}
	cfg.SLLegendary.found={}
	cfg.SLLegendary.powers={}
	cfg.SLLegendary.ItemBonusListID={}
	
	cfg.trinket={}
	cfg.haste=GetCombatRatingBonus(CR_HASTE_MELEE)
	cfg.ap=UnitAttackPower("player")
	cfg.spells_ignore ={
		[GetSpellInfo(75)]=true --Auto Shot
		}

	cfg.Weapons={}
	cfg.Weapons.Main, _, _, cfg.Weapons.Off = GetWeaponEnchantInfo()
	cfg.onGround = true
	cfg.spells_aoe={}
	cfg.spells_single={}
	cfg.spells_range={}
	cfg.noaoe=false
	cfg.mode="auto"
	cfg.numcase=0
	cfg.heroism={[32182]=true,[2825]=true,[80353]=true,[90355]=true,[49016]=true,[178207]=true}
	cfg.case_current="none"

	cfg.DOT={}
	cfg.DOT.aura=nil
	cfg.DOT.spell=nil
	cfg.DOT.id=nil
	cfg.DOT.targets={}
	cfg.DOT.num=0
	cfg.DOT.num_show=1
	cfg.DOT.maxtick=3
	cfg.DOT.Update=false
	cfg.DOT.lastUpdate=0
	cfg.DOT.func=nil

	cfg.TrackAura={}
	cfg.TrackAura.aura=nil
	cfg.TrackAura.max=0
	cfg.TrackAura.targets={}

	cfg.shape={}
	cfg.shape.name="human"
	cfg.shape.id=0 --GetShapeshiftFormID()
	cfg.shape.SpellID=0 --select(5,GetShapeshiftFormInfo(GetShapeshiftForm()))
	cfg.cd_num=nil
	cfg.cd_last=nil
	cfg.CD={}
	cfg.cd_options=0
	cfg.dispell={}
	cfg.dispell["player"]={}
	cfg.dispell["player"].now=false
	cfg.dispell["player"].powerType={}
	cfg.dispell["player"].spell=nil
	cfg.dispell["target"]={}
	cfg.dispell["target"].now=false
	cfg.dispell["target"].powerType={}
	cfg.dispell["target"].spell=nil
	
	


	cfg.talents={}

	cfg.Casting={}
	cfg.Casting.name=false
	cfg.Casting.caststart=0
	cfg.Casting.castend=0
	cfg.Casting.iscasting=false
	cfg.Casting.cost=0
	cfg.Casting.castid=false
	cfg.Casting.id=false

	cfg.Channeling={}
	cfg.Channeling.ischanneling=false
	cfg.Channeling.cost=0
	cfg.Channeling.id=false
	cfg.Channeling.spell=false
	cfg.Channeling.startTime=0
	cfg.Channeling.endTime=0
	cfg.Channeling.nointerupt=false
	cfg.TargetCastYou=false
	cfg.TargetYou=false
	cfg.fixspells={}
	cfg.fixspells_func={}
	cfg.fixspells_num=0

	cfg.pvp = UnitPlayerControlled("target")
	cfg.Range ={}
	cfg.RangeColor = {}
	--cfg.inRange = nil
	cfg.inRangeSpell="none"
	cfg.norepeat=false

	lib.OnCleave=nil
	cfg.Cleave=nil --{}
	--[[cfg.Cleave["none"]={}
	cfg.Cleave["none"].threshold=cfg.Cleave.threshold
	cfg.Cleave["none"].cast_time=0
	cfg.Cleave["none"].hit_time=0
	cfg.Cleave["none"].num=0
	cfg.Cleave["none"].targets={}]]
	--cfg.CleaveAdder={}
--	cfg.Cleave.num=0
--	cfg.cleave_current="none"
--	cfg.cleave_current="none"
--	cfg.Cleave.threshold=2
	cfg.Id2Cleave={}
--	cfg.Id2Cleave={}
--	cfg.cleave_id=

	cfg.NoSaveSpell = nil
	cfg.SaveSpell = nil
	cfg.MonitorSpells =false

	cfg.Artifact={}
	cfg.Artifact.traits={}
	cfg.traits = {}
	lib.OnUpdateHealth=nil
	lib.OnTargetChanged=nil
	Heddmain.info_DOT:SetText("")
	Heddmain.info:SetText("")
	cfg.Bear_D5S_Frame:UnregisterAllEvents()
	cfg.Bear_D5S_Frame:Hide()
	cfg.Bear_D5S_Frame.damageTable = {}
	cfg.Bear_D5S_Frame.updateInterval = 0.1
	cfg.Bear_D5S_Frame.timeElapsed = 0
	cfg.Bear_D5S_Frame.damageTP5S = 0
	cfg.Bear_D5S_Frame.idFR = 22842
	cfg.Bear_D5S_Frame.anouncedHealing = 0
	cfg.Bear_D5S_Frame.nextcast = 0
	cfg.Bear_D5S_Frame.info="ratio";
	Heddmain.tracker.size=24
	Heddmain.tracker.lastframe=nil
	Heddmain.tracker.updateInterval = 0.05
	Heddmain.tracker.MAXVALUE=10
	Heddmain.tracker.alpha=0.3
	lib.Regen=lib.Regen_Orig
	cfg.stagger = 0
	cfg.stagger_hp = 0
	cfg.stagger_hp_ps =0
	cfg.Brewmaster_Frame:UnregisterAllEvents()
	cfg.Brewmaster_Frame:Hide()

	cfg.pandemic_multiplier = 0.3
	
	cfg.legendary={}
	cfg.legendary_equiped={}
	cfg.lastcast="no"
end
lib.defaults()

cfg.shapes={}
cfg.shapes={
[1]="Cat",
[2]="Tree",
--[3]="Travel",
--[4]="Aquatic",
[5]="Bear",
--[16]="Spirit Wolf",
[17]="Battle",
[18]="Defensive",
[19]="Berserker",
[22]="Metamorphosis",
--[27]="Flight",
[28]="Shadow",
[30]="Stealth",
[31]="Moonkin"
}

cfg.HasDOTEvent = {}
cfg.HasDOTEvent = {
	["SPELL_AURA_APPLIED"]=true,
	["SPELL_AURA_REFRESH"]=true,
	["SPELL_PERIODIC_DAMAGE"]=true,
	["SPELL_PERIODIC_HEAL"]=true,
	["SPELL_PERIODIC_MISSED"]=true
	}

cfg.CleaveSpellEvent = {
	["SPELL_PERIODIC_DAMAGE"]=true,
	["SPELL_DAMAGE"]=true,
	["SPELL_MISSED"]=true
}
cfg.ReloadSpell = {
}


cfg.tagetlvl={
["minus"] = 0,
["normal"] = 1,
["rare"] = 2,
["elite"] = 2,
["rareelite"] = 2,
["worldboss"] = 3
}

cfg.power_class_spec = {
["WARLOCK"] = {
	[1] = "SOUL_SHARDS"
	}
}

cfg.RuneforgeLegendaryAbility={}
cfg.RuneforgeLegendaryAbility[327508]={ItemBonusListID=6823; ID=2; Name_lang="Slick Ice"}
cfg.RuneforgeLegendaryAbility[327284]={ItemBonusListID=6828; ID=3; Name_lang="Cold Front"}
cfg.RuneforgeLegendaryAbility[327364]={ItemBonusListID=6829; ID=4; Name_lang="Freezing Winds"}
cfg.RuneforgeLegendaryAbility[327492]={ItemBonusListID=6830; ID=5; Name_lang="Glacial Fragments"}
cfg.RuneforgeLegendaryAbility[327489]={ItemBonusListID=6831; ID=6; Name_lang="Expanded Potential"}
cfg.RuneforgeLegendaryAbility[327365]={ItemBonusListID=6832; ID=7; Name_lang="Disciplinary Command"}
cfg.RuneforgeLegendaryAbility[333393]={ItemBonusListID=6937; ID=8; Name_lang="Grisly Icicle"}
cfg.RuneforgeLegendaryAbility[327351]={ItemBonusListID=6834; ID=9; Name_lang="Temporal Warp"}
cfg.RuneforgeLegendaryAbility[333030]={ItemBonusListID=6931; ID=10; Name_lang="Fevered Incantation"}
cfg.RuneforgeLegendaryAbility[333097]={ItemBonusListID=6932; ID=11; Name_lang="Firestorm"}
cfg.RuneforgeLegendaryAbility[333167]={ItemBonusListID=6933; ID=12; Name_lang="Molten Skyfall"}
cfg.RuneforgeLegendaryAbility[333313]={ItemBonusListID=6934; ID=13; Name_lang="Sun King's Blessing"}
cfg.RuneforgeLegendaryAbility[332769]={ItemBonusListID=6926; ID=14; Name_lang="Arcane Infinity"}
cfg.RuneforgeLegendaryAbility[332892]={ItemBonusListID=6927; ID=15; Name_lang="Arcane Bombardment"}
cfg.RuneforgeLegendaryAbility[332928]={ItemBonusListID=6928; ID=16; Name_lang="Siphon Storm"}
cfg.RuneforgeLegendaryAbility[333373]={ItemBonusListID=6936; ID=17; Name_lang="Triune Ward"}
cfg.RuneforgeLegendaryAbility[337504]={ItemBonusListID=7041; ID=18; Name_lang="Collective Anguish"}
cfg.RuneforgeLegendaryAbility[337775]={ItemBonusListID=7052; ID=19; Name_lang="Fel Bombardment"}
cfg.RuneforgeLegendaryAbility[337534]={ItemBonusListID=7043; ID=20; Name_lang="Darkglare Medallion"}
cfg.RuneforgeLegendaryAbility[337539]={ItemBonusListID=7044; ID=21; Name_lang="Darkest Hour"}
cfg.RuneforgeLegendaryAbility[346264]={ItemBonusListID=7218; ID=22; Name_lang="Darker Nature"}
cfg.RuneforgeLegendaryAbility[337551]={ItemBonusListID=7050; ID=23; Name_lang="Chaos Theory"}
cfg.RuneforgeLegendaryAbility[337685]={ItemBonusListID=7051; ID=24; Name_lang="Erratic Fel Core"}
cfg.RuneforgeLegendaryAbility[346279]={ItemBonusListID=7219; ID=25; Name_lang="Burning Wound"}
cfg.RuneforgeLegendaryAbility[337541]={ItemBonusListID=7045; ID=26; Name_lang="Spirit of the Darkness Flame"}
cfg.RuneforgeLegendaryAbility[337544]={ItemBonusListID=7046; ID=27; Name_lang="Razelikh's Defilement"}
cfg.RuneforgeLegendaryAbility[337545]={ItemBonusListID=7047; ID=28; Name_lang="Fel Flame Fortification"}
cfg.RuneforgeLegendaryAbility[337547]={ItemBonusListID=7048; ID=29; Name_lang="Fiery Soul"}
cfg.RuneforgeLegendaryAbility[334974]={ItemBonusListID=6953; ID=30; Name_lang="Superstrain"}
cfg.RuneforgeLegendaryAbility[335177]={ItemBonusListID=6954; ID=31; Name_lang="Phearomones"}
cfg.RuneforgeLegendaryAbility[334728]={ItemBonusListID=6947; ID=32; Name_lang="Death's Embrace"}
cfg.RuneforgeLegendaryAbility[334724]={ItemBonusListID=6948; ID=33; Name_lang="Grip of the Everlasting"}
cfg.RuneforgeLegendaryAbility[334501]={ItemBonusListID=6940; ID=34; Name_lang="Bryndaor's Might"}
cfg.RuneforgeLegendaryAbility[334525]={ItemBonusListID=6941; ID=35; Name_lang="Crimson Rune Weapon"}
cfg.RuneforgeLegendaryAbility[334580]={ItemBonusListID=6943; ID=36; Name_lang="Gorefiend's Domination"}
cfg.RuneforgeLegendaryAbility[334547]={ItemBonusListID=6942; ID=37; Name_lang="Vampiric Aura"}
cfg.RuneforgeLegendaryAbility[334583]={ItemBonusListID=6944; ID=38; Name_lang="Koltira's Favor"}
cfg.RuneforgeLegendaryAbility[334678]={ItemBonusListID=6945; ID=39; Name_lang="Biting Cold"}
cfg.RuneforgeLegendaryAbility[334692]={ItemBonusListID=6946; ID=40; Name_lang="Absolute Zero"}
cfg.RuneforgeLegendaryAbility[341724]={ItemBonusListID=7160; ID=41; Name_lang="Rage of the Frozen Champion"}
cfg.RuneforgeLegendaryAbility[334836]={ItemBonusListID=6949; ID=42; Name_lang="Reanimated Shambler"}
cfg.RuneforgeLegendaryAbility[334888]={ItemBonusListID=6950; ID=43; Name_lang="Frenzied Monstrosity"}
cfg.RuneforgeLegendaryAbility[334898]={ItemBonusListID=6951; ID=44; Name_lang="Death's Certainty"}
cfg.RuneforgeLegendaryAbility[334949]={ItemBonusListID=6952; ID=45; Name_lang="Deadliest Coil"}
cfg.RuneforgeLegendaryAbility[338658]={ItemBonusListID=7086; ID=46; Name_lang="Draught of Deep Focus"}
cfg.RuneforgeLegendaryAbility[338657]={ItemBonusListID=7085; ID=47; Name_lang="Circle of Life and Death"}
cfg.RuneforgeLegendaryAbility[340059]={ItemBonusListID=7110; ID=48; Name_lang="Lycara's Fleeting Glimpse"}
cfg.RuneforgeLegendaryAbility[338608]={ItemBonusListID=7084; ID=49; Name_lang="Oath of the Elder Druid"}
cfg.RuneforgeLegendaryAbility[338661]={ItemBonusListID=7087; ID=50; Name_lang="Oneth's Clear Vision"}
cfg.RuneforgeLegendaryAbility[338668]={ItemBonusListID=7088; ID=51; Name_lang="Primordial Arcanic Pulsar"}
cfg.RuneforgeLegendaryAbility[339942]={ItemBonusListID=7107; ID=52; Name_lang="Balance of All Things"}
cfg.RuneforgeLegendaryAbility[339949]={ItemBonusListID=7108; ID=53; Name_lang="Timeworn Dreambinder"}
cfg.RuneforgeLegendaryAbility[340053]={ItemBonusListID=7109; ID=54; Name_lang="Frenzyband"}
cfg.RuneforgeLegendaryAbility[339139]={ItemBonusListID=7091; ID=55; Name_lang="Apex Predator's Craving"}
cfg.RuneforgeLegendaryAbility[339141]={ItemBonusListID=7090; ID=56; Name_lang="Eye of Fearful Symmetry"}
cfg.RuneforgeLegendaryAbility[339144]={ItemBonusListID=7089; ID=57; Name_lang="Cat-Eye Curio"}
cfg.RuneforgeLegendaryAbility[339060]={ItemBonusListID=7092; ID=58; Name_lang="Luffa-Infused Embrace"}
cfg.RuneforgeLegendaryAbility[339063]={ItemBonusListID=7093; ID=59; Name_lang="The Natural Order's Will"}
cfg.RuneforgeLegendaryAbility[339056]={ItemBonusListID=7094; ID=60; Name_lang="Ursoc's Fury Remembered"}
cfg.RuneforgeLegendaryAbility[339062]={ItemBonusListID=7095; ID=61; Name_lang="Legacy of the Sleeper"}
cfg.RuneforgeLegendaryAbility[339064]={ItemBonusListID=7096; ID=62; Name_lang="Memory of the Mother Tree"}
cfg.RuneforgeLegendaryAbility[338831]={ItemBonusListID=7097; ID=63; Name_lang="The Dark Titan's Lesson"}
cfg.RuneforgeLegendaryAbility[338829]={ItemBonusListID=7098; ID=64; Name_lang="Verdant Infusion"}
cfg.RuneforgeLegendaryAbility[338832]={ItemBonusListID=7099; ID=65; Name_lang="Vision of Unending Growth"}
cfg.RuneforgeLegendaryAbility[336742]={ItemBonusListID=7003; ID=66; Name_lang="Call of the Wild"}
cfg.RuneforgeLegendaryAbility[336743]={ItemBonusListID=7004; ID=67; Name_lang="Nessingwary's Trapping Apparatus"}
cfg.RuneforgeLegendaryAbility[336745]={ItemBonusListID=7005; ID=68; Name_lang="Soulforge Embers"}
cfg.RuneforgeLegendaryAbility[336747]={ItemBonusListID=7006; ID=69; Name_lang="Craven Strategem"}
cfg.RuneforgeLegendaryAbility[336819]={ItemBonusListID=7007; ID=70; Name_lang="Dire Command"}
cfg.RuneforgeLegendaryAbility[336822]={ItemBonusListID=7008; ID=71; Name_lang="Flamewaker's Cobra Sting"}
cfg.RuneforgeLegendaryAbility[336830]={ItemBonusListID=7009; ID=72; Name_lang="Qa'pla, Eredun War Order"}
cfg.RuneforgeLegendaryAbility[336844]={ItemBonusListID=7010; ID=73; Name_lang="Rylakstalker's Piercing Fangs"}
cfg.RuneforgeLegendaryAbility[336849]={ItemBonusListID=7011; ID=74; Name_lang="Eagletalon's True Focus"}
cfg.RuneforgeLegendaryAbility[336867]={ItemBonusListID=7012; ID=75; Name_lang="Surging Shots"}
cfg.RuneforgeLegendaryAbility[336870]={ItemBonusListID=7013; ID=76; Name_lang="Serpentstalker's Trickery"}
cfg.RuneforgeLegendaryAbility[336878]={ItemBonusListID=7014; ID=77; Name_lang="Secrets of the Unblinking Vigil"}
cfg.RuneforgeLegendaryAbility[336895]={ItemBonusListID=7015; ID=78; Name_lang="Wildfire Cluster"}
cfg.RuneforgeLegendaryAbility[336901]={ItemBonusListID=7016; ID=79; Name_lang="Rylakstalker's Confounding Strikes"}
cfg.RuneforgeLegendaryAbility[336902]={ItemBonusListID=7017; ID=80; Name_lang="Latent Poison Injectors"}
cfg.RuneforgeLegendaryAbility[336907]={ItemBonusListID=7018; ID=81; Name_lang="Butcher's Bone Fragments"}
cfg.RuneforgeLegendaryAbility[343250]={ItemBonusListID=7184; ID=82; Name_lang="Escape from Reality"}
cfg.RuneforgeLegendaryAbility[337298]={ItemBonusListID=7082; ID=83; Name_lang="Invoker's Delight"}
cfg.RuneforgeLegendaryAbility[337294]={ItemBonusListID=7080; ID=84; Name_lang="Swiftsure Wraps"}
cfg.RuneforgeLegendaryAbility[337296]={ItemBonusListID=7081; ID=85; Name_lang="Fatal Touch"}
cfg.RuneforgeLegendaryAbility[338138]={ItemBonusListID=7076; ID=86; Name_lang="Charred Passions"}
cfg.RuneforgeLegendaryAbility[337288]={ItemBonusListID=7077; ID=87; Name_lang="Stormstout's Last Keg"}
cfg.RuneforgeLegendaryAbility[337290]={ItemBonusListID=7078; ID=88; Name_lang="Celestial Infusion"}
cfg.RuneforgeLegendaryAbility[337570]={ItemBonusListID=7079; ID=89; Name_lang="Shaohao's Might"}
cfg.RuneforgeLegendaryAbility[337172]={ItemBonusListID=7075; ID=90; Name_lang="Ancient Teachings of the Monastery"}
cfg.RuneforgeLegendaryAbility[337225]={ItemBonusListID=7073; ID=91; Name_lang="Yu'lon's Whisper"}
cfg.RuneforgeLegendaryAbility[337343]={ItemBonusListID=7074; ID=92; Name_lang="Clouded Focus"}
cfg.RuneforgeLegendaryAbility[337473]={ItemBonusListID=7072; ID=93; Name_lang="Tear of Morning"}
cfg.RuneforgeLegendaryAbility[337481]={ItemBonusListID=7070; ID=94; Name_lang="Xuen's Treasure"}
cfg.RuneforgeLegendaryAbility[337334]={ItemBonusListID=7068; ID=95; Name_lang="Keefer's Skyreach"}
cfg.RuneforgeLegendaryAbility[337483]={ItemBonusListID=7071; ID=96; Name_lang="Jade Ignition"}
cfg.RuneforgeLegendaryAbility[337292]={ItemBonusListID=7069; ID=97; Name_lang="Last Emperor's Capacitor"}
cfg.RuneforgeLegendaryAbility[337600]={ItemBonusListID=7053; ID=98; Name_lang="Uther's Devotion"}
cfg.RuneforgeLegendaryAbility[337746]={ItemBonusListID=7055; ID=100; Name_lang="Of Dusk and Dawn"}
cfg.RuneforgeLegendaryAbility[337681]={ItemBonusListID=7056; ID=101; Name_lang="The Magistrate's Judgment"}
cfg.RuneforgeLegendaryAbility[340458]={ItemBonusListID=7128; ID=102; Name_lang="Maraad's Dying Breath"}
cfg.RuneforgeLegendaryAbility[337825]={ItemBonusListID=7059; ID=103; Name_lang="Shock Barrier"}
cfg.RuneforgeLegendaryAbility[337812]={ItemBonusListID=7057; ID=104; Name_lang="Shadowbreaker, Dawn of the Sun"}
cfg.RuneforgeLegendaryAbility[337777]={ItemBonusListID=7058; ID=105; Name_lang="Inflorescence of the Sunwell"}
cfg.RuneforgeLegendaryAbility[337831]={ItemBonusListID=7060; ID=106; Name_lang="Holy Avenger's Engraved Sigil"}
cfg.RuneforgeLegendaryAbility[337838]={ItemBonusListID=7061; ID=107; Name_lang="The Ardent Protector's Sanctum"}
cfg.RuneforgeLegendaryAbility[337847]={ItemBonusListID=7062; ID=108; Name_lang="Bulwark of Righteous Fury"}
cfg.RuneforgeLegendaryAbility[337850]={ItemBonusListID=7063; ID=109; Name_lang="Reign of Endless Kings"}
cfg.RuneforgeLegendaryAbility[337257]={ItemBonusListID=7067; ID=110; Name_lang="Tempest of the Lightbringer"}
cfg.RuneforgeLegendaryAbility[337297]={ItemBonusListID=7066; ID=111; Name_lang="Relentless Inquisitor"}
cfg.RuneforgeLegendaryAbility[337638]={ItemBonusListID=7065; ID=112; Name_lang="Vanguard's Momentum"}
cfg.RuneforgeLegendaryAbility[337247]={ItemBonusListID=7064; ID=113; Name_lang="Final Verdict"}
cfg.RuneforgeLegendaryAbility[340080]={ItemBonusListID=7114; ID=114; Name_lang="Invigorating Shadowdust"}
cfg.RuneforgeLegendaryAbility[340079]={ItemBonusListID=7113; ID=115; Name_lang="Essence of Bloodfang"}
cfg.RuneforgeLegendaryAbility[340078]={ItemBonusListID=7112; ID=116; Name_lang="Tiny Toxic Blade"}
cfg.RuneforgeLegendaryAbility[340076]={ItemBonusListID=7111; ID=117; Name_lang="Mark of the Master Assassin"}
cfg.RuneforgeLegendaryAbility[340081]={ItemBonusListID=7115; ID=118; Name_lang="Dashing Scoundrel"}
cfg.RuneforgeLegendaryAbility[340082]={ItemBonusListID=7116; ID=119; Name_lang="Doomblade"}
cfg.RuneforgeLegendaryAbility[340083]={ItemBonusListID=7117; ID=120; Name_lang="Zoldyck Insignia"}
cfg.RuneforgeLegendaryAbility[340084]={ItemBonusListID=7118; ID=121; Name_lang="Duskwalker's Patch"}
cfg.RuneforgeLegendaryAbility[340088]={ItemBonusListID=7122; ID=122; Name_lang="Concealed Blunderbuss"}
cfg.RuneforgeLegendaryAbility[340087]={ItemBonusListID=7121; ID=123; Name_lang="Celerity"}
cfg.RuneforgeLegendaryAbility[340086]={ItemBonusListID=7120; ID=124; Name_lang="Guile Charm"}
cfg.RuneforgeLegendaryAbility[340085]={ItemBonusListID=7119; ID=125; Name_lang="Greenskin's Wickers"}
cfg.RuneforgeLegendaryAbility[340089]={ItemBonusListID=7123; ID=126; Name_lang="Finality"}
cfg.RuneforgeLegendaryAbility[340090]={ItemBonusListID=7124; ID=127; Name_lang="Akaari's Soul Fragment"}
cfg.RuneforgeLegendaryAbility[340091]={ItemBonusListID=7125; ID=128; Name_lang="The Rotten"}
cfg.RuneforgeLegendaryAbility[340092]={ItemBonusListID=7126; ID=129; Name_lang="Deathly Shadows"}
cfg.RuneforgeLegendaryAbility[336741]={ItemBonusListID=6985; ID=130; Name_lang="Ancestral Reminder"}
cfg.RuneforgeLegendaryAbility[336739]={ItemBonusListID=6986; ID=131; Name_lang="Deeptremor Stone"}
cfg.RuneforgeLegendaryAbility[336738]={ItemBonusListID=6987; ID=132; Name_lang="Deeply Rooted Elements"}
cfg.RuneforgeLegendaryAbility[336735]={ItemBonusListID=6988; ID=133; Name_lang="Chains of Devastation"}
cfg.RuneforgeLegendaryAbility[336734]={ItemBonusListID=6989; ID=134; Name_lang="Skybreaker's Fiery Demise"}
cfg.RuneforgeLegendaryAbility[336730]={ItemBonusListID=6990; ID=135; Name_lang="Elemental Equilibrium"}
cfg.RuneforgeLegendaryAbility[336215]={ItemBonusListID=6991; ID=136; Name_lang="Echoes of Great Sundering"}
cfg.RuneforgeLegendaryAbility[336063]={ItemBonusListID=6992; ID=137; Name_lang="Windspeaker's Lava Resurgence"}
cfg.RuneforgeLegendaryAbility[335902]={ItemBonusListID=6993; ID=138; Name_lang="Doom Winds"}
cfg.RuneforgeLegendaryAbility[335899]={ItemBonusListID=6994; ID=139; Name_lang="Legacy of the Frost Witch"}
cfg.RuneforgeLegendaryAbility[335897]={ItemBonusListID=6995; ID=140; Name_lang="Witch Doctor's Wolf Bones"}
cfg.RuneforgeLegendaryAbility[335895]={ItemBonusListID=6996; ID=141; Name_lang="Primal Lava Actuators"}
cfg.RuneforgeLegendaryAbility[335893]={ItemBonusListID=6997; ID=142; Name_lang="Jonat's Natural Focus"}
cfg.RuneforgeLegendaryAbility[335891]={ItemBonusListID=6998; ID=143; Name_lang="Spiritwalker's Tidal Totem"}
cfg.RuneforgeLegendaryAbility[335889]={ItemBonusListID=6999; ID=144; Name_lang="Primal Tide Core"}
cfg.RuneforgeLegendaryAbility[335886]={ItemBonusListID=7000; ID=145; Name_lang="Earthen Harmony"}
cfg.RuneforgeLegendaryAbility[341804]={ItemBonusListID=7161; ID=146; Name_lang="Measured Contemplation"}
cfg.RuneforgeLegendaryAbility[336897]={ItemBonusListID=7002; ID=147; Name_lang="Twins of the Sun Priestess"}
cfg.RuneforgeLegendaryAbility[336370]={ItemBonusListID=6975; ID=148; Name_lang="Cauterizing Shadows"}
cfg.RuneforgeLegendaryAbility[336470]={ItemBonusListID=6972; ID=149; Name_lang="Vault of Heavens"}
cfg.RuneforgeLegendaryAbility[336011]={ItemBonusListID=6976; ID=150; Name_lang="The Penitent One"}
cfg.RuneforgeLegendaryAbility[336507]={ItemBonusListID=6978; ID=151; Name_lang="Crystalline Reflection"}
cfg.RuneforgeLegendaryAbility[336133]={ItemBonusListID=6979; ID=152; Name_lang="Kiss of Death"}
cfg.RuneforgeLegendaryAbility[336067]={ItemBonusListID=6980; ID=153; Name_lang="Clarity of Mind"}
cfg.RuneforgeLegendaryAbility[337477]={ItemBonusListID=6984; ID=154; Name_lang="X'anshi, Return of Archbishop Benedictus"}
cfg.RuneforgeLegendaryAbility[336314]={ItemBonusListID=6977; ID=155; Name_lang="Harmonious Apparatus"}
cfg.RuneforgeLegendaryAbility[336266]={ItemBonusListID=6974; ID=156; Name_lang="Flash Concentration"}
cfg.RuneforgeLegendaryAbility[336400]={ItemBonusListID=6973; ID=157; Name_lang="Divine Image"}
cfg.RuneforgeLegendaryAbility[336165]={ItemBonusListID=6981; ID=158; Name_lang="Painbreaker Psalm"}
cfg.RuneforgeLegendaryAbility[336143]={ItemBonusListID=6982; ID=159; Name_lang="Shadowflame Prism"}
cfg.RuneforgeLegendaryAbility[336214]={ItemBonusListID=6983; ID=160; Name_lang="Eternal Call to the Void"}
cfg.RuneforgeLegendaryAbility[342415]={ItemBonusListID=7162; ID=161; Name_lang="Talbadar's Stratagem"}
cfg.RuneforgeLegendaryAbility[337020]={ItemBonusListID=7025; ID=162; Name_lang="Wilfred's Sigil of Superior Summoning"}
cfg.RuneforgeLegendaryAbility[337038]={ItemBonusListID=7026; ID=163; Name_lang="Claw of Endereth"}
cfg.RuneforgeLegendaryAbility[337057]={ItemBonusListID=7027; ID=164; Name_lang="Relic of Demonic Synergy"}
cfg.RuneforgeLegendaryAbility[337065]={ItemBonusListID=7028; ID=165; Name_lang="Pillars of the Dark Portal"}
cfg.RuneforgeLegendaryAbility[337106]={ItemBonusListID=7029; ID=166; Name_lang="Perpetual Agony of Azj'Aqir"}
cfg.RuneforgeLegendaryAbility[337111]={ItemBonusListID=7030; ID=167; Name_lang="Sacrolash's Dark Strike"}
cfg.RuneforgeLegendaryAbility[337122]={ItemBonusListID=7031; ID=168; Name_lang="Malefic Wrath"}
cfg.RuneforgeLegendaryAbility[337128]={ItemBonusListID=7032; ID=169; Name_lang="Wrath of Consumption"}
cfg.RuneforgeLegendaryAbility[337135]={ItemBonusListID=7033; ID=170; Name_lang="Implosive Potential"}
cfg.RuneforgeLegendaryAbility[337141]={ItemBonusListID=7034; ID=171; Name_lang="Grim Inquisitor's Dread Calling"}
cfg.RuneforgeLegendaryAbility[337146]={ItemBonusListID=7035; ID=172; Name_lang="Forces of the Horned Nightmare"}
cfg.RuneforgeLegendaryAbility[337159]={ItemBonusListID=7036; ID=173; Name_lang="Balespider's Burning Core"}
cfg.RuneforgeLegendaryAbility[337163]={ItemBonusListID=7037; ID=174; Name_lang="Odr, Shawl of the Ymirjar"}
cfg.RuneforgeLegendaryAbility[337166]={ItemBonusListID=7038; ID=175; Name_lang="Cinders of the Azj'Aqir"}
cfg.RuneforgeLegendaryAbility[337169]={ItemBonusListID=7039; ID=176; Name_lang="Madness of the Azj'Aqir"}
cfg.RuneforgeLegendaryAbility[337272]={ItemBonusListID=7040; ID=177; Name_lang="Embers of the Diabolic Raiment"}
cfg.RuneforgeLegendaryAbility[335214]={ItemBonusListID=6955; ID=178; Name_lang="Leaper"}
cfg.RuneforgeLegendaryAbility[335758]={ItemBonusListID=6971; ID=179; Name_lang="Seismic Reverberation"}
cfg.RuneforgeLegendaryAbility[335253]={ItemBonusListID=6958; ID=180; Name_lang="Misshapen Mirror"}
cfg.RuneforgeLegendaryAbility[335266]={ItemBonusListID=6959; ID=181; Name_lang="Signet of Tormented Kings"}
cfg.RuneforgeLegendaryAbility[335458]={ItemBonusListID=6962; ID=182; Name_lang="Enduring Blow"}
cfg.RuneforgeLegendaryAbility[335274]={ItemBonusListID=6960; ID=183; Name_lang="Battlelord"}
cfg.RuneforgeLegendaryAbility[335451]={ItemBonusListID=6961; ID=184; Name_lang="Exploiter"}
cfg.RuneforgeLegendaryAbility[335282]={ItemBonusListID=6970; ID=185; Name_lang="Unhinged"}
cfg.RuneforgeLegendaryAbility[335555]={ItemBonusListID=6963; ID=186; Name_lang="Cadence of Fujieda"}
cfg.RuneforgeLegendaryAbility[335567]={ItemBonusListID=6964; ID=187; Name_lang="Deathmaker"}
cfg.RuneforgeLegendaryAbility[335582]={ItemBonusListID=6965; ID=188; Name_lang="Reckless Defense"}
cfg.RuneforgeLegendaryAbility[335594]={ItemBonusListID=6966; ID=189; Name_lang="Will of the Berserker"}
cfg.RuneforgeLegendaryAbility[335229]={ItemBonusListID=6956; ID=190; Name_lang="Thunderlord"}
cfg.RuneforgeLegendaryAbility[335239]={ItemBonusListID=6957; ID=191; Name_lang="The Wall"}
cfg.RuneforgeLegendaryAbility[335629]={ItemBonusListID=6967; ID=192; Name_lang="Unbreakable Will"}
cfg.RuneforgeLegendaryAbility[335718]={ItemBonusListID=6969; ID=193; Name_lang="Reprisal"}
cfg.RuneforgeLegendaryAbility[337594]={ItemBonusListID=7054; ID=196; Name_lang="The Mad Paragon"}
cfg.RuneforgeLegendaryAbility[338477]={ItemBonusListID=7100; ID=199; Name_lang="Echo of Eonar"}
cfg.RuneforgeLegendaryAbility[339344]={ItemBonusListID=7101; ID=200; Name_lang="Judgment of the Arbiter"}
cfg.RuneforgeLegendaryAbility[339340]={ItemBonusListID=7102; ID=201; Name_lang="Norgannon's Sagacity"}
cfg.RuneforgeLegendaryAbility[339348]={ItemBonusListID=7103; ID=202; Name_lang="Sephuz's Proclamation"}
cfg.RuneforgeLegendaryAbility[339351]={ItemBonusListID=7104; ID=203; Name_lang="Stable Phantasma Lure"}
cfg.RuneforgeLegendaryAbility[339058]={ItemBonusListID=7105; ID=204; Name_lang="Third Eye of the Jailer"}
cfg.RuneforgeLegendaryAbility[338743]={ItemBonusListID=7106; ID=205; Name_lang="Vitality Sacrifice"}
cfg.RuneforgeLegendaryAbility[340197]={ItemBonusListID=7159; ID=206; Name_lang="Maw Rattle"}
cfg.RuneforgeLegendaryAbility[353882]={ItemBonusListID=7466; ID=210; Name_lang="Rampant Transference"}
cfg.RuneforgeLegendaryAbility[353822]={ItemBonusListID=7467; ID=211; Name_lang="Final Sentence"}
cfg.RuneforgeLegendaryAbility[353699]={ItemBonusListID=7468; ID=212; Name_lang="Insatiable Hunger"}
cfg.RuneforgeLegendaryAbility[353447]={ItemBonusListID=7458; ID=213; Name_lang="Abomination's Frenzy"}
cfg.RuneforgeLegendaryAbility[353577]={ItemBonusListID=7469; ID=214; Name_lang="Glory"}
cfg.RuneforgeLegendaryAbility[354131]={ItemBonusListID=7470; ID=215; Name_lang="Sinful Surge"}
cfg.RuneforgeLegendaryAbility[354161]={ItemBonusListID=7471; ID=216; Name_lang="Nature's Fury"}
cfg.RuneforgeLegendaryAbility[354123]={ItemBonusListID=7472; ID=217; Name_lang="Locust Swarm"}
cfg.RuneforgeLegendaryAbility[354186]={ItemBonusListID=7473; ID=218; Name_lang="Harmonic Echo"}
cfg.RuneforgeLegendaryAbility[354109]={ItemBonusListID=7474; ID=220; Name_lang="Sinful Hysteria"}
cfg.RuneforgeLegendaryAbility[354294]={ItemBonusListID=7475; ID=221; Name_lang="Death's Fathom"}
cfg.RuneforgeLegendaryAbility[354333]={ItemBonusListID=7476; ID=222; Name_lang="Sinful Delight"}
cfg.RuneforgeLegendaryAbility[354115]={ItemBonusListID=7477; ID=223; Name_lang="Kindred Affinity"}
cfg.RuneforgeLegendaryAbility[354473]={ItemBonusListID=7478; ID=224; Name_lang="Toxic Onslaught"}
cfg.RuneforgeLegendaryAbility[354118]={ItemBonusListID=7571; ID=226; Name_lang="Celestial Spirits"}
cfg.RuneforgeLegendaryAbility[354647]={ItemBonusListID=7570; ID=228; Name_lang="Splintered Elements"}
cfg.RuneforgeLegendaryAbility[354703]={ItemBonusListID=7572; ID=229; Name_lang="Obedience"}
cfg.RuneforgeLegendaryAbility[354731]={ItemBonusListID=7573; ID=230; Name_lang="Deathspike"}
cfg.RuneforgeLegendaryAbility[354837]={ItemBonusListID=7577; ID=231; Name_lang="Resounding Clarity"}
cfg.RuneforgeLegendaryAbility[355098]={ItemBonusListID=7679; ID=234; Name_lang="Divine Resonance"}
cfg.RuneforgeLegendaryAbility[355099]={ItemBonusListID=7680; ID=235; Name_lang="Duty-Bound Gavel"}
cfg.RuneforgeLegendaryAbility[355886]={ItemBonusListID=7681; ID=236; Name_lang="Agony Gaze"}
cfg.RuneforgeLegendaryAbility[355890]={ItemBonusListID=7698; ID=237; Name_lang="Blazing Slaughter"}
cfg.RuneforgeLegendaryAbility[355893]={ItemBonusListID=7699; ID=238; Name_lang="Blind Faith"}
cfg.RuneforgeLegendaryAbility[355996]={ItemBonusListID=7700; ID=239; Name_lang="Demonic Oath"}
cfg.RuneforgeLegendaryAbility[355447]={ItemBonusListID=7701; ID=240; Name_lang="Radiant Embers"}
cfg.RuneforgeLegendaryAbility[355100]={ItemBonusListID=7702; ID=241; Name_lang="Seasons of Plenty"}
cfg.RuneforgeLegendaryAbility[356391]={ItemBonusListID=7703; ID=242; Name_lang="Bwonsamdi's Pact"}
cfg.RuneforgeLegendaryAbility[356392]={ItemBonusListID=7704; ID=243; Name_lang="Shadow Word: Manipulation"}
cfg.RuneforgeLegendaryAbility[356592]={ItemBonusListID=7707; ID=244; Name_lang="Bountiful Brew"}
cfg.RuneforgeLegendaryAbility[356218]={ItemBonusListID=7708; ID=246; Name_lang="Seeds of Rampant Growth"}
cfg.RuneforgeLegendaryAbility[356250]={ItemBonusListID=7709; ID=247; Name_lang="Elemental Conduit"}
cfg.RuneforgeLegendaryAbility[356254]={ItemBonusListID=7710; ID=248; Name_lang="Languishing Soul Detritus"}
cfg.RuneforgeLegendaryAbility[356344]={ItemBonusListID=7711; ID=249; Name_lang="Shard of Annihilation"}
cfg.RuneforgeLegendaryAbility[356362]={ItemBonusListID=7712; ID=250; Name_lang="Decaying Soul Satchel"}
cfg.RuneforgeLegendaryAbility[356259]={ItemBonusListID=7713; ID=251; Name_lang="Contained Perpetual Explosion"}
cfg.RuneforgeLegendaryAbility[356262]={ItemBonusListID=7714; ID=252; Name_lang="Pact of the Soulstalkers"}
cfg.RuneforgeLegendaryAbility[356264]={ItemBonusListID=7715; ID=253; Name_lang="Bag of Munitions"}
cfg.RuneforgeLegendaryAbility[356375]={ItemBonusListID=7716; ID=254; Name_lang="Fragments of the Elder Antlers"}
cfg.RuneforgeLegendaryAbility[356618]={ItemBonusListID=7717; ID=255; Name_lang="Pouch of Razor Fragments"}
cfg.RuneforgeLegendaryAbility[356684]={ItemBonusListID=7718; ID=256; Name_lang="Call to Arms"}
cfg.RuneforgeLegendaryAbility[356705]={ItemBonusListID=7721; ID=257; Name_lang="Faeline Harmony"}
cfg.RuneforgeLegendaryAbility[356789]={ItemBonusListID=7722; ID=258; Name_lang="Raging Vesper Vortex"}
cfg.RuneforgeLegendaryAbility[356818]={ItemBonusListID=7726; ID=259; Name_lang="Sinister Teachings"}
cfg.RuneforgeLegendaryAbility[356877]={ItemBonusListID=7727; ID=260; Name_lang="Heart of the Fae"}
cfg.RuneforgeLegendaryAbility[356395]={ItemBonusListID=7728; ID=261; Name_lang="Spheres' Harmony"}
cfg.RuneforgeLegendaryAbility[356390]={ItemBonusListID=7729; ID=262; Name_lang="Pallid Command"}
cfg.RuneforgeLegendaryAbility[357996]={ItemBonusListID=7730; ID=263; Name_lang="Elysian Might"}
cfg.RuneforgeLegendaryAbility[364758]={ItemBonusListID=8119; ID=264; Name_lang="Unity"}
cfg.RuneforgeLegendaryAbility[364824]={ItemBonusListID=8120; ID=267; Name_lang="Unity"}
cfg.RuneforgeLegendaryAbility[364814]={ItemBonusListID=8121; ID=268; Name_lang="Unity"}
cfg.RuneforgeLegendaryAbility[364743]={ItemBonusListID=8122; ID=269; Name_lang="Unity"}
cfg.RuneforgeLegendaryAbility[364852]={ItemBonusListID=8123; ID=270; Name_lang="Unity"}
cfg.RuneforgeLegendaryAbility[364857]={ItemBonusListID=8124; ID=271; Name_lang="Unity"}
cfg.RuneforgeLegendaryAbility[364642]={ItemBonusListID=8125; ID=272; Name_lang="Unity"}
cfg.RuneforgeLegendaryAbility[364911]={ItemBonusListID=8126; ID=273; Name_lang="Unity"}
cfg.RuneforgeLegendaryAbility[364922]={ItemBonusListID=8127; ID=274; Name_lang="Unity"}
cfg.RuneforgeLegendaryAbility[364738]={ItemBonusListID=8128; ID=275; Name_lang="Unity"}
cfg.RuneforgeLegendaryAbility[364939]={ItemBonusListID=8129; ID=276; Name_lang="Unity"}
cfg.RuneforgeLegendaryAbility[364929]={ItemBonusListID=8130; ID=277; Name_lang="Unity"}




--[[normal - Normal
	minus - Small
	rare - Rare
	elite - Elite
	rareelite - Rare-Elite
	worldboss - World Boss]]
