-- get the addon namespace
local addon, ns = ...
local cfg = ns.cfg
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")
ns.lib = lib

local power_old={}

--UNIT_POWER_UPDATE
Hedd.POWER={}
Hedd.POWER["MANA"] = Enum.PowerType.Mana
Hedd.POWER["RAGE"] = Enum.PowerType.Rage
Hedd.POWER["FOCUS"] = Enum.PowerType.Focus
Hedd.POWER["ENERGY"] = Enum.PowerType.Energy
Hedd.POWER["COMBO_POINTS"] = Enum.PowerType.ComboPoints
Hedd.POWER["RUNES"] = Enum.PowerType.Runes
Hedd.POWER["RUNIC_POWER"] = Enum.PowerType.RunicPower
Hedd.POWER["SOUL_SHARDS"] = Enum.PowerType.SoulShards
Hedd.POWER["LUNAR_POWER"] = Enum.PowerType.LunarPower
Hedd.POWER["HOLY_POWER"] = Enum.PowerType.HolyPower
Hedd.POWER["MAELSTROM"] = Enum.PowerType.Maelstrom
Hedd.POWER["CHI"] = Enum.PowerType.Chi
Hedd.POWER["INSANITY"] = Enum.PowerType.Insanity
Hedd.POWER["ARCANE_CHARGES"] = Enum.PowerType.ArcaneCharges
Hedd.POWER["FURY"] = Enum.PowerType.Fury
Hedd.POWER["PAIN"] = Enum.PowerType.Pain

Hedd.POWERCOMBO={}
Hedd.POWERCOMBO["COMBO_POINTS"] = Enum.PowerType.ComboPoints
Hedd.POWERCOMBO["SOUL_SHARDS"] = Enum.PowerType.SoulShards
Hedd.POWERCOMBO["HOLY_POWER"] = Enum.PowerType.HolyPower
Hedd.POWERCOMBO["CHI"] = Enum.PowerType.Chi
Hedd.POWERCOMBO["ARCANE_CHARGES"] = Enum.PowerType.ArcaneCharges

Hedd.POWER_NUM={}
for k, v in pairs(Hedd.POWER) do
	Hedd.POWER_NUM[v]=k
end

lib.PowerEnum2Type=function(PowerEnum)
	if type(PowerEnum) == "string" then
		PowerEnum=Enum.PowerType[PowerEnum]
	end
	return Hedd.POWER_NUM[PowerEnum] or 0
end

lib.InitPower = function()
	--lib.SetPower()
	--lib.AddResourceBar(cfg.Power.max)
	--lib.ChangeResourceBarType(cfg.Power.type)
	cfg.Power.type_num,cfg.Power.type=UnitPowerType("player")
	lib.AddResource(cfg.Power)
	lib.UpdatePower()
	cfg.Update=true
end

--[[lib.SetPower = function() --powerType
	
end]]

lib.SetPowerFunction = function(func,run)
	if run then
		func()
	end
	cfg.Power.OnUpdate=cfg.Power.OnUpdate or {}
	table.insert(cfg.Power.OnUpdate,#cfg.Power.OnUpdate+1,func)
	return #cfg.Power.OnUpdate
	--cfg.Power.onpower=func
end

lib.Regen=function()
	return (select(2,GetPowerRegen()))
end

lib.Regen_Orig=lib.Regen

lib.UpdatePower = function(powerType)
	powerType=powerType or cfg.Power.type
	if cfg.Power.type~=powerType then
		lib.UpdateAltPower(powerType)
		return
	end
	hedlib.shallowCopy(cfg.Power,power_old)
	cfg.Power.now=UnitPower("player") --,cfg.Power.type_num)
	cfg.Power.max=UnitPowerMax("player") --,cfg.Power.type_num)
	cfg.Power.regen = lib.Regen()
	if cfg.Power.regen<1 then cfg.Power.regen=0 end
	if cfg.class=="DEATHKNIGHT" and cfg.talenttree==1 and cfg.Power.regen>2 then
		cfg.Power.regen=cfg.Power.regen/10
	end
	cfg.Power.real=math.floor(cfg.Power.now+lib.CastingPower())
	if cfg.Power.real>cfg.Power.max then cfg.Power.real=cfg.Power.max end
	
	lib.UpdateResource(cfg.Power)
	if not hedlib.ArrayNotChanged(cfg.Power,power_old) then
		lib.UpdateAllSpells("power")
		if cfg.Power.OnUpdate then
			for num_func,func in pairs(cfg.Power.OnUpdate) do
				func()
			end
		end
		cfg.Update=true
	end
end

lib.PowerPercent = function()
	return cfg.Power.now/cfg.Power.max*100
end

local castpower
lib.CastingPower = function()
	if lib.IsCasting() then
		return ((cfg.Casting.castend-GetTime())*cfg.Power.regen-cfg.Casting.cost)
	end
	return 0
end

lib.Power = function()
	return math.min(cfg.Power.max,(cfg.Power.now-cfg.Casting.cost+(lib.SpellCastingLeft()*cfg.Power.regen)))
end

lib.PowerInTime = function(t)
	return math.min(cfg.Power.max,(cfg.Power.now-cfg.Casting.cost+(t*cfg.Power.regen)))
end

lib.PowerMax = function()
	return cfg.Power.max
end

lib.SearchAltPower = function()
	for i,v in pairs(Hedd.POWERCOMBO) do
		if UnitPowerMax("player",v)>0 then --and pmax<=10
			lib.SetAltPower(v)
			return true
		end
	end
	return nil
end


lib.SetAltPower = function(alt_powerType,nocombo,func)
	cfg.AltPower.type=Hedd.POWER_NUM[alt_powerType]
	cfg.AltPower.type_num=alt_powerType
	cfg.AltPower.now=UnitPower("player",cfg.AltPower.type_num)
	cfg.AltPower.max=UnitPowerMax("player",cfg.AltPower.type_num)
	cfg.AltPower.func=func or nil
	if not nocombo then
		lib.AddResource(cfg.AltPower)
	end
	cfg.Update=true
end

altpower_old={}
lib.UpdateAltPower = function(powerType)
	if cfg.AltPower.type_num==cfg.Power.type_num or cfg.AltPower.type~=powerType then return end
	hedlib.shallowCopy(cfg.AltPower,altpower_old)
	cfg.AltPower.now = UnitPower("player", cfg.AltPower.type_num)
	cfg.AltPower.max=UnitPowerMax("player", cfg.AltPower.type_num)
	if not hedlib.ArrayNotChanged(cfg.AltPower,altpower_old) then
		lib.UpdateResource(cfg.AltPower)
		if cfg.AltPower.func then cfg.AltPower.func() end
		lib.UpdateAllSpells("alt")
		cfg.Update=true
	end
end

lib.mypower = function(power)
	if cfg.Power.now<power then
		return 9999
	else
		return 0
	end
end

lib.Time2Power = function(power)
	if cfg.Power.now<power+cfg.Casting.cost and cfg.Power.regen<=0 then return (lib.mypower(power)) end
	if cfg.Power.regen>0 then
		return math.max(lib.SpellCastingLeft(),(power-cfg.Power.now+cfg.Casting.cost)/cfg.Power.regen)
	else
		return math.max(lib.SpellCastingLeft())
	end
end

lib.Time2MaxPower = function()
	if cfg.Power.now<cfg.Power.max+cfg.Casting.cost and cfg.Power.regen<=0 then return (lib.mypower(cfg.Power.max)) end
	if cfg.Power.regen>0 then
		return math.max(lib.SpellCastingLeft(),(cfg.Power.max-cfg.Power.now+cfg.Casting.cost)/cfg.Power.regen)
	else
		return math.max(lib.SpellCastingLeft())
	end
end

lib.TimeEnergyGain = function(t)
	return (cfg.Power.regen*t)
end

lib.PowerTime = function(t)
	return math.min(cfg.Power.now+cfg.Power.regen*t,cfg.Power.max)
end
